#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <sprlib.h>
#include <io.h>
#include <fcntl.h>
#include <math.h>
#define  IMAGENAME "tools.raw"
#define  IMAGEX 106
#define  IMAGEY 82
#define  IMAGESIZE 8692
#define  SAMPLENAME "samplesz.dat"
#define  NMEASURES 9

int read_image(unsigned char** buffer)
{
int handle;
int error=TRUE;
unsigned tmp;
	if( (handle=open(IMAGENAME,O_RDONLY|O_BINARY))!=-1){
		if( (*buffer=(unsigned char*)malloc((size_t) IMAGESIZE*sizeof(unsigned char*)))!=NULL)
			if( (unsigned)read(handle,*buffer,(unsigned)IMAGESIZE) != (unsigned)IMAGESIZE )
				error=TRUE;
			else
				error=FALSE;
		close(handle);
	}
	return(error);
}




int main(int argc,char** argv)
{
	unsigned char *image;
	double *vector_image;
	int gdriver = DETECT, gmode, errorcode;     /* request auto detection */
	int i,j;
	int class;
	int x,y,color;
	double kvecinos=13;
	int nvecinos;
	DATASET* muestras;
	int error=TRUE;

	sprinit(INIT_STD);
	if( (muestras=load_dataset(SAMPLENAME))!=NULL)
		if(read_image(&image) !=TRUE)
			if( (vector_image=vector(1,NMEASURES))!=NULL){
				knn_init(muestras);
				initgraph(&gdriver, &gmode, "");/* initialize graphics mode */
				errorcode = graphresult();        /* read result of initialization */
				if (errorcode != grOk) { /* an error occurred */
					printf("Graphics error: %s\n", grapherrormsg(errorcode));
					printf("Press any key to halt:");
					getch();
					exit(1);             /* return with error code */
				}

				for (j=1;j<IMAGEX-2;j++)
					for(i=1;i<IMAGEY-2;i++){
						vector_image[1]=image[(i-1)*IMAGEX+j+1];
						vector_image[2]=image[i*IMAGEX+j+1];
						vector_image[3]=image[(i+1)*IMAGEX+j+1];
						vector_image[4]=image[(i-1)*IMAGEX+j];
						vector_image[5]=image[i*IMAGEX+j];
						vector_image[6]=image[(i+1)*IMAGEX+j];
						vector_image[7]=image[(i-1)*IMAGEX+j-1];
						vector_image[8]=image[i*IMAGEX+j-1];
						vector_image[9]=image[(i+1)*IMAGEX+j-1];

						nvecinos=knn_classify((int)kvecinos,0,vector_image);
						color = (nvecinos>kvecinos/2)?WHITE:YELLOW;
						putpixel(j, IMAGEY-i, color);
						}

				getch();
				error=FALSE;
				knn_free();
				free(image);
				free_vector(vector_image,1,NMEASURES);
				free_dataset(muestras);
				closegraph();
			}

   if(error==TRUE) printf("Error en la ejecucin");
   return(0);
}
